#include"Switcher.h"
#include<OS.h>

SwitcherView :: SwitcherView(BRect r) 
	: BView(r,"Switcher",B_FOLLOW_NONE,B_WILL_DRAW | B_PULSE_NEEDED)
{
	BMenuItem 	*item;
	BMessage	*message;
//	LoadLabels();
	
	strcpy(label,"123456789");
		
	menu = new BPopUpMenu("",FALSE,FALSE);

	message=new BMessage(ssChangeMode);
	message->AddLong("mode",B_8_BIT_640x480);
	item=new BMenuItem("640x480-8bit",message);
	item->SetTarget(be_app);
	menu->AddItem(item);
	
	message=new BMessage(ssChangeMode);
	message->AddLong("mode",B_8_BIT_800x600);
	item=new BMenuItem("800x600-8bit",message);
	item->SetTarget(be_app);
	menu->AddItem(item);
	
	message=new BMessage(ssChangeMode);
	message->AddLong("mode",B_8_BIT_1024x768);
	item=new BMenuItem("1024x768-8bit",message);
	item->SetTarget(be_app);
	menu->AddItem(item);
	
	message=new BMessage(ssChangeMode);
	message->AddLong("mode",B_8_BIT_1152x900);
	item=new BMenuItem("1152x900-8bit",message);
	item->SetTarget(be_app);
	menu->AddItem(item);

	menu->AddSeparatorItem();	
	
	item=new BMenuItem("Quit",new BMessage(B_QUIT_REQUESTED));
	item->SetTarget(be_app);
	menu->AddItem(item);
	
	SetViewColor(0,0,0,0);
}


/*void SwitcherView :: LoadLabels()
{
	FILE *in;
		
	in=fopen("Switcher.conf","r");
	char temp[80];

	if(in==NULL)
	{
		printf("File error: Please check Switcher.conf\n");
		return;
	}
	for(int n=0;n<32;n++)
	{
		fgets(temp,80,in);
		label[n]=(char*)malloc(strlen(temp)+1);
		strcpy(label[n],temp);
	}
	fclose(in);
}
*/

void SwitcherView :: MouseDown(BPoint p)
{
    ulong buttons;
	screen_info sInfo;

    buttons = Window()->CurrentMessage()->FindLong("buttons"); 

    if(buttons==B_PRIMARY_MOUSE_BUTTON)
	{
		currentWorkspace=((int)(p.x)/20);
		activate_workspace(currentWorkspace);
		Invalidate();
	}
	else if(buttons==B_SECONDARY_MOUSE_BUTTON)
	{
		menu->Go(ConvertToScreen(p),TRUE);	
	}
}

void SwitcherView :: Pulse()
{
	int cw=current_workspace();
	if(currentWorkspace!=cw) 
	{
		currentWorkspace=cw;
		Invalidate();
	}
}

void SwitcherView :: Draw(BRect updateRect)
{
	float pos=10;
	SetHighColor(0,255,0,0);
	for(int n=0;n<9;n++)
	{
		if(n==currentWorkspace) SetHighColor(255,0,0);
		DrawChar(label[n],*(new BPoint(pos,11)));
		if(n==currentWorkspace) SetHighColor(0,255,0);
		pos+=20;	
	}
}


// SWITCHER WINDOW

SwitcherWindow::SwitcherWindow(BRect r)
	 : BWindow(r, "Switcher", B_BORDERED_WINDOW, B_NOT_RESIZABLE | B_WILL_ACCEPT_FIRST_CLICK,B_ALL_WORKSPACES)
{
	Lock();
	SwitcherView *view;
	r.OffsetTo(BPoint(0, 0));
	view=new SwitcherView(r);
	AddChild(view);
	Unlock();
	Show();
}


bool SwitcherWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return TRUE;
}


// SWITCHER APP

SwitcherApp::SwitcherApp(ulong sig) : BApplication(sig)
{
	BRect			r;
	SwitcherWindow	*theWindow;

	r.Set(80,0,80+10+180,15);	
	theWindow = new SwitcherWindow(r);		
}


void SwitcherApp :: MessageReceived(BMessage *message)
{
	if(message->what==ssChangeMode)
	{
		set_screen_space(current_workspace(),message->FindLong("mode"),TRUE);
	}
	else inherited::MessageReceived(message);
}


main()
{

	SwitcherApp*	app;

	app = new SwitcherApp('SPSW');
	app->Run();
		

	delete(app);	
	return(0);
	
}